> For the complete documentation index, see [llms.txt](https://docs.rawrshak.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.rawrshak.io/developers/smart-contracts/libraries/libasset.md).

# LibAsset

> <mark style="color:blue;">**STRUCTURE OBJECTS**</mark>
>
> CreateData
>
> MintData
>
> BurnData
>
> Asset
>
> AssetUri
>
> AssetRoyalties
>
> SystemApprovalPair

```solidity
struct CreateData {
    string publicDataUri;
    string hiddenDataUri;
    uint256 maxSupply;
    address royaltyReceiver;
    uint24 royaltyRate;
}
```

```solidity
struct MintData {
    address to;
    uint256[] tokenIds;
    uint256[] amounts;
    uint256 nonce;
    address signer;
    bytes signature;
}
```

```solidity
struct BurnData {
    address account;
    uint256[] tokenIds;
    uint256[] amounts;
}
```

```solidity
struct Asset {
    string[] dataUri;
    uint256 version;
}
```

```solidity
struct AssetUri {
    uint256 tokenId;
    string uri;
}
```

```solidity
struct AssetRoyalties {
    uint256 tokenId;
    address royaltyReceiver;
    uint24 royaltyRate;
}
```

```solidity
struct SystemApprovalPair {
        address operator;
        bool approved;
    }
```

```solidity
struct SystemApprovalPair {
    address operator;
    bool approved;
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.rawrshak.io/developers/smart-contracts/libraries/libasset.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
